(* dfinition d'une premire classe pour les points *)

class point (x_init,y_init) =
object
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
  method distance () = sqrt (float(x*x + y*y))
end ;;

let x = new point(1,1);;
x#to_string ();;


(* dfinition d'une deuxime classe de points colors *)
class colored_point (x,y) c =
object
  inherit point (x,y)
  val mutable c = c
  method get_color = c
  method set_color nc = c <- nc
  method to_string () = "( " ^ (string_of_int x) ^ 
			", " ^ (string_of_int y) ^ ")" ^
			" [" ^ c ^ "] "
end ;;

let y = new colored_point(3,4) "rouge";;
y#to_string ();;  (* la ralisation de cette mthode a change *)
y#distance ();;   (* mthode hrite *)

(* mieux : utiliser la mthode to_string de la classe point  *)
(* pour la rdfinition de la mthode to_string              *)
class colored_point (x,y) c =
object
  inherit point (x,y) as super
  val mutable c = c
  method get_color = c
  method set_color nc = c <- nc
  method to_string () = super#to_string() ^ " [" ^ c ^ "] "
end ;;

let y = new colored_point(3,4) "rouge";;
y#to_string ();;  (* la ralisation de cette mthode a change *)
y#distance ();;   (* mthode hrite *)
