(* Dmonstration des types ouverts *)

(* la seule information sur l'argument de la fonction f qu'on peut
   infrer est que x possde une mthode get_x sans argument *)
let f o = o#get_x ;;

(* les deux classes des points et des point colors, comme avant *)

class point (x_init,y_init) =
object
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end 

class colored_point (x,y) c =
object
  inherit point (x,y) as super
  val mutable c = c
  method get_color = c
  method set_color nc = c <- nc
  method to_string () = super#to_string () ^ " [" ^ c ^ "] "
end

let x = new point (0,1);;
let y = new colored_point (2,3) "vert";;
f x;;
f y;;
