(* une classe virtuelle pour les objets avec mthode  print  *)

class virtual printable = object(self)
  method print () = print_string (self#to_string ()); print_newline ()
  method virtual to_string : unit -> string
end

(* la classe  point  comme d'habitude *)
class point (x_init,y_init) =
object
  inherit printable
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
  method distance () = sqrt (float(x*x + y*y))
end

(* cela ne marche pas parce que le type de la mthode  m  sera ouvert *)
class t p = object
  val x = p
  method m () = p#to_string ()
end

(* premire solution : dire que p possde au moins les mthodes de la classe
   printable *)
class t (p : #printable)  = object
  val x = p
  method m () = x#to_string ()
end

(* deuxime solution : contraindre le type du rsultat de la mthode m *)
class t p = object
  val x = p
  method m = (x#to_string () : string)
end

let x = new point (0,1);;
let y = new t x;;
y#m;;
