(* erreur : variable de type libre *)
class pair x0 y0 =
object
  val x = x0 
  val y = y0
  method fst = x
  method snd = y
end 
  
(* classe paramtrique *)
class ['a,'b] pair (x0:'a) (y0:'b) =
object
  val x = x0
  val y = y0
  method fst = x
  method snd = y
end
  
let p = new pair 2 'X';;
p#fst;;
let q = new pair 3.12 true;;
q#snd;;

(* il faut indiquer les paramtres d'une classe quand on hrite d'une classe
   paramtre  *)

class ['a,'b] acc_pair (x0 : 'a) (y0 : 'b) = 
object
  inherit ['a,'b] pair x0 y0 
  method get1 z = if x = z then y else raise Not_found
end
  
let p = new acc_pair 3 true;;
p#get1 3;;

(* Ici, la classe par_point n'est pas paramtrique *)
class pair_point (p1,p2) = 
object
inherit [point,point] pair p1 p2
end

(* dmonstration des contraintes de types *)
class virtual printable = object(self)
  method print () = print_string (self#to_string ()); print_newline ()
  method virtual to_string : unit -> string
end

class printable_pair (x0 ) (y0 ) = 
object
  inherit [printable, printable] acc_pair x0 y0
  method print () = x#print(); y#print ()
end

(* on ne peut pas utiliser cette classe pour des objets d'une classe autre
   que printable *)

class point (x_init,y_init) =
object
  inherit printable
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end

let p = new point (0,1);;
let q = new point (2,3);;

let r = new printable_pair p q;;

(* premier essai :  ouvrir  le type de printable *)

class printable_pair (x0 ) (y0 ) = 
object
  inherit [ #printable, #printable ] acc_pair x0 y0
  method print () = x#print(); y#print ()
end

(* la bonne solution consiste en l'utilisation d'une contrainte *)
class ['a,'b] printable_pair (x0 ) (y0 ) = 
object
  constraint 'a = #printable
  constraint 'b = #printable 
  inherit ['a,'b] acc_pair x0 y0
  method print () = x#print(); y#print ()
end

let r = new printable_pair p q;;
r#print();;
