(* dfinition d'une premire classe pour les points *)

class point (x_init,y_init) =
object
  val mutable x = x_init
  val mutable y = y_init
  method get_x = x
  method get_y = y
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
  method distance () = sqrt (float(x*x + y*y))
end ;;

let x = new point(1,1);;
x#distance ();;
x#rmoveto(2,3);;
x#distance ();;

(* dfinition d'une classe d'images qui contient un tableau de points *)
class picture n =
  (* l'argument n est le nombre maximal de points *)
object
  val tab = Array.create n (new point(0,0))
  val mutable ind = 0
    (* la premire case non occuppe *)
  method add p = 
    try tab.(ind)<-p ; ind <- ind + 1 
    with Invalid_argument("Array.set")
	-> failwith ("picture.add:ind =" ^ (string_of_int ind))
  method remove () = if (ind > 0) then ind <-ind-1
  method to_string () = 
    let s = ref "[" 
    in for i=0 to ind-1 do s:= !s ^ " " ^ tab.(i)#to_string() done ;
      (!s) ^ "]"
end ;;

let p = new picture 5;;
p#to_string ();;
p#add x;;
p#add (new point (17,42));;
p#to_string ();;
