class point (x_init,y_init) =
object
  val mutable x = x_init
  val mutable y = y_init
  method moveto (a,b) = x <- a ; y <- b 
  method rmoveto (dx,dy) = x <- x + dx ; y <- y + dy 
  method to_string () = 
    "(" ^ (string_of_int x) ^ ", " ^ (string_of_int y) ^")"
end 

class point_mem (x0,y0) =
object(self)
  inherit point (x0,y0) as super
  val mutable old_x = x0
  val mutable old_y = y0
  method private mem_pos () = old_x <- x ; old_y <- y
  method moveto (x1, y1) = self#mem_pos () ; super#moveto (x1, y1)
  method rmoveto (x1, y1) = self#mem_pos () ; super#rmoveto (x1, y1)
  method undo () = x <- old_x; y <- old_y
end 

let p = new point_mem (0,0);;
p#moveto(42,42);;
p#rmoveto(17,17);;
p#to_string ();;
p#undo ();;
p#to_string ();;


(* la mthode mem_pos est prive, elle ne peut pas tre invoque de 
   l'extrieur 
*)

p#mem_pos ();; (* erreur *)

p = new point (42,42);; (* erreur de typage *)

(* les methodes prives sont herites par les classes drives *)

class colored_point_mem (x0,y0) color =
object(self)
  inherit point_mem (x0,y0) as super
  val c = color
  method to_string () = super#to_string () ^ " de couleur " ^ c
end

let p = new colored_point_mem (0,0) "pink";;
p#moveto(42,42);;
p#rmoveto(17,17);;
p#to_string ();;
p#undo ();;
p#to_string ();;

